<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Convert extends CI_Controller {

	public function __construct() 
	{
		parent::__construct();
		
		$this->lang->load('account_general', get_language());
		$this->load->model('member_model');
    }
	
	public function index()
	{
		save_current_url(base_url() . 'convert/');
		
		if($this->session->userdata('user_type') && $this->session->userdata('user_type') == MEMBER) {
			if($this->session->userdata('member_allowed_convert') AND $this->session->userdata('member_allowed_convert') == 1) {
				$this->load->model('member_model');
				$data = $this->member_model->get_member_account_details();
				$data['setting'] = $this->member_model->get_setting_rates();
				
				$data['page_title'] = $this->lang->line('website_name') . ' | ' . $this->lang->line('hf_convert') . ' | ' . $this->lang->line('hf_account_convert');
				
				$this->load->view('convert', $data);
			}
			else {
				redirect('', 'refresh');
			}	
		}
		else {
			redirect('', 'refresh');
		}
	}

	public function submit()
	{
		if($this->session->userdata('user_type') && $this->session->userdata('user_type') == MEMBER) {
			if($this->session->userdata('member_allowed_convert') AND $this->session->userdata('member_allowed_convert') == 1) {
				if($_POST) {
					$rs = $this->member_model->member_convert();
					
					echo $rs;
				}
				else {
					echo $this->lang->line('permission_denied');
				}
			}
			else {
				echo $this->lang->line('permission_denied');
			}	
		}
		else {
			echo $this->lang->line('permission_denied');
		}
	}
	
	public function listing()
	{
		save_current_url(base_url() . 'convert/listing/');
		
		if($this->session->userdata('user_type') && $this->session->userdata('user_type') == MEMBER) {
			$data['page_title'] = $this->lang->line('website_name') . ' | ' . $this->lang->line('hf_convert') . ' | ' . $this->lang->line('hf_convert_history');
			
			$this->load->view('convert_listing', $data);
		}
		else {
			redirect('', 'refresh');
		}
	}
	
	public function getlist()
    {
		if($this->session->userdata('user_type') && $this->session->userdata('user_type') == MEMBER) {
			$this->lang->load('account_general', get_language());
		
			/* Array of database columns which should be read and sent back to DataTables. Use a space where
			 * you want to insert a non-database field (for example a counter or static image)
			 */
			$aColumns = array(
				$this->db->dbprefix('member_converts') . '.transaction_date',
				$this->db->dbprefix('member_converts') . '.transaction_type',
				$this->db->dbprefix('member_converts') . '.debit_amount',
				$this->db->dbprefix('member_converts') . '.status',
			);
			
			// DB table to use
			$sTable = 'member_converts';
			//
			
			$this->db->where($this->db->dbprefix('member_converts') . '.from_member_id', $this->session->userdata('member_id'));
			
			$iDisplayStart = $this->input->get_post('iDisplayStart', true);
			$iDisplayLength = $this->input->get_post('iDisplayLength', true);
			$iSortCol_0 = $this->input->get_post('iSortCol_0', true);
			$iSortingCols = $this->input->get_post('iSortingCols', true);
			$sSearch = $this->input->get_post('sSearch', true);
			$sEcho = $this->input->get_post('sEcho', true);
		
			// Paging
			if(isset($iDisplayStart) && $iDisplayLength != '-1')
			{
				$this->db->limit($this->db->escape_str($iDisplayLength), $this->db->escape_str($iDisplayStart));
			}
			
			// Ordering
			if(isset($iSortCol_0))
			{
				for($i=0; $i<intval($iSortingCols); $i++)
				{
					$iSortCol = $this->input->get_post('iSortCol_'.$i, true);
					$bSortable = $this->input->get_post('bSortable_'.intval($iSortCol), true);
					$sSortDir = $this->input->get_post('sSortDir_'.$i, true);
		
					if($bSortable == 'true')
					{
						$this->db->order_by($aColumns[intval($this->db->escape_str($iSortCol))], $this->db->escape_str($sSortDir));
					}
				}
			}
			
			/* 
			 * Filtering
			 * NOTE this does not match the built-in DataTables filtering which does it
			 * word by word on any field. It's possible to do here, but concerned about efficiency
			 * on very large tables, and MySQL's regex functionality is very limited
			 */
			if(isset($sSearch) && !empty($sSearch))
			{
				for($i=0; $i<count($aColumns); $i++)
				{
					$bSearchable = $this->input->get_post('bSearchable_'.$i, true);
					
					// Individual column filtering
					if(isset($bSearchable) && $bSearchable == 'true')
					{
						$this->db->or_like($aColumns[$i], $this->db->escape_like_str($sSearch));
					}
				}
			}
			
			// Select Data
			$this->db->select('SQL_CALC_FOUND_ROWS '.str_replace(' , ', ' ', implode(', ', $aColumns)), false);
			$rResult = $this->db->get($sTable);
		
			// Data set length after filtering
			$this->db->select('FOUND_ROWS() AS found_rows');
			$iFilteredTotal = $this->db->get()->row()->found_rows;
		
			// Total data set length
			$iTotal = $this->db->count_all($sTable);
		
			// Output
			$output = array(
				'sEcho' => intval($sEcho),
				'iTotalRecords' => $iTotal,
				'iTotalDisplayRecords' => $iFilteredTotal,
				'aaData' => array()
			);
			
			foreach($rResult->result_array() as $aRow)
			{
				$row = array();
				
				$row[] = date('Y-m-d H:i:s', $aRow['transaction_date']);
				
				switch($aRow['transaction_type']) {
					case 1: $row[] = $this->lang->line('wallet_2') . ' => ' . $this->lang->line('wallet_1'); break;
					case 2: $row[] = $this->lang->line('wallet_1') . ' => ' . $this->lang->line('wallet_3'); break;
				}
				
				$row[] = number_format($aRow['debit_amount'], 2, '.', ',');
				
				switch($aRow['status']) {
					case 1: $row[] = '<span class="badge bg-success">' . $this->lang->line('convert_confirmed') . '</span>'; break;
					case 2: $row[] = '<span class="badge bg-danger">' . $this->lang->line('convert_cancelled') . '</span>'; break;
					default: $row[] = '<span class="badge bg-primary">' . $this->lang->line('convert_pending') . '</span>'; break;
				}
				
				$output['aaData'][] = $row;
			}
		
			echo json_encode($output);
		}	
    }
}

/* End of file withdrawal.php */
/* Location: ./application/controllers/withdrawal.php */